
// File LGINFN.BPL

// Login function

GET "SYSHDM.BPL"
GET "STATUS.BPL"
GET "PDMAN.BPL"
GET "SYSHDG.BPL"
GET "ERRCOD.BPL"
GET "FILEHD.BPL"

MANIFEST $( NORMAL.PRIORITY = 500; BACKGROUND.PRIORITY = 10 $)

LET LOGIN(B) = VALOF
$( LET USERID = B!LGB.USERID
   AND BATCHJOB = CUPROC!PD.PRIV & INHPASS
   LET BATCHPRIV = BATCHJOB -> BATCH, 0

   IF PRIVILEGED(LOGGEDIN) DO OVJOB.ERROR(3)

   P(LV DISCBUFFER1.USE, ST.CBW)

   $( LET R = SEARCHMFD(USERID)
      IF R = 0 DO
      $( V(LV DISCBUFFER1.USE)
         ERROR.REPLY(ERR.NME)
      $)
      UNLESS BATCHJOB DO
      $( UNLESS R!MFD.PASSWD = ENCODE(B!LGB.PASSWD) DO
         $( V(LV DISCBUFFER1.USE)
            ERROR.REPLY(ERR.PNM)
         $)
      $)
      IF R!MFD.UFD = 0 DO
      $( LET S = CREATEUFD(USERID, 0)
         IF S = 0 DO
            PRINT(-1, "?Unable to create UFD*C*L")
         R!MFD.UFD := S
         WRITE.FROM.BUFFER1(CUDIRBLK)
      $)
      CUPROC!PD.USERID := USERID
      CUPROC!PD.UFD := R!MFD.UFD
      CUPROC!PD.PRIV :=
         (R!MFD.PRIV & LOGINMASK) \/ LOGGEDIN \/ BATCHPRIV

      V(LV DISCBUFFER1.USE)

      CUPROC!PD.PRIO := BATCHJOB -> BACKGROUND.PRIORITY, NORMAL.PRIORITY
      CUPROC!PD.STATUS := 0
      RESULTIS 0
   $)
$)

// End of file LGINFN.BPL

